unit main;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  JvLookOut, JvComponent, ExtCtrls, StdCtrls, Menus, JvHotLink, JvLabel,
  JvMailTo, JvLinkLabel, JvColorBox, ComCtrls, JvMemoEx, JvTypedEdit, Noise,
  JvWinDialogs, Math, JvProgressDlg, JvBaseDlg, JvPerforated, JvMagnet,
  JvCreatedWith, JvFormButton, Geometry, Edtprocstage;

const
  CM_REMOVE_PROCTEX = WM_USER+ 100;

type
  TProcTexStage = record
                    Image : TImage;
                    ScrollBox : TScrollBox;
                    Stage : Byte;
                    StageLabel : TLabel;
                  end;
type
  TMainForm = class(TForm)
    JvLookOut: TJvLookOut;
    LookOutPage1: TJvLookOutPage;
    LookOutPage2: TJvLookOutPage;
    LookOutPage3: TJvLookOutPage;
    HeightmapViewButton: TJvExpressButton;
    HeightMapCreateButton: TJvExpressButton;
    MainPanel: TPanel;
    HeightmapView: TGroupBox;
    HeightmapCreate: TGroupBox;
    HeightMapTools: TPanel;
    StartGroupBox: TGroupBox;
    Label1: TLabel;
    Label2: TLabel;
    JvMailTo1: TJvMailTo;
    HeightMapScrollBox: TScrollBox;
    HeightMapImage: TImage;
    Label3: TLabel;
    HeightMapWidth: TLabel;
    HeightMapHeight: TLabel;
    GroupBox1: TGroupBox;
    GroupBox2: TGroupBox;
    Label4: TLabel;
    NewWidth: TJvIntegerEdit;
    Label5: TLabel;
    NewHeight: TJvIntegerEdit;
    Label6: TLabel;
    PerlinRandomSeed: TJvIntegerEdit;
    PerlinXScale: TJvFloatEdit2;
    Label7: TLabel;
    Label8: TLabel;
    PerlinYScale: TJvFloatEdit2;
    Label9: TLabel;
    PerlinOctaves: TJvIntegerEdit;
    CreatePerlinNoiseButton: TButton;
    LoadHeightmapButton: TButton;
    SaveHeightmapButton: TButton;
    OpenDialog: TJvOpenDialog2000;
    SaveDialog: TJvSaveDialog2000;
    JvHotLink2: TJvHotLink;
    ProceduralTextureViewButton: TJvExpressButton;
    ProceduralTextureCreate: TJvExpressButton;
    LightingView: TJvExpressButton;
    LightingCreate: TJvExpressButton;
    Label10: TLabel;
    Label11: TLabel;
    Label12: TLabel;
    CreditsButton: TJvExpressButton;
    JvProgress: TJvProgressDlg;
    ProcTexSettings: TGroupBox;
    ProceduralTexturesBox: TScrollBox;
    Panel1: TPanel;
    JvCreatedWith1: TJvCreatedWith;
    JvFormButton1: TJvFormButton;
    Label13: TLabel;
    Label14: TLabel;
    CreateProceduralTexButton: TButton;
    ProceduralTexureView: TGroupBox;
    ProceduralTextureScrollBox: TScrollBox;
    ProceduralTextureImage: TImage;
    ProceduralTextureTools: TPanel;
    SaveProceduralTextureButton: TButton;
    Label15: TLabel;
    LightMapView: TGroupBox;
    LightmapScrollBox: TScrollBox;
    LightMapImage: TImage;
    LightmapToolsPanel: TPanel;
    LightMapSaveButton: TButton;
    LightMapCreate: TGroupBox;
    LightingCreateButton: TButton;
    HeightScaleEdit: TJvFloatEdit2;
    Label19: TLabel;
    AmbientLight: TScrollBar;
    DiffuseLight: TScrollBar;
    Label20: TLabel;
    Label21: TLabel;
    LightRotation: TScrollBar;
    LightPostionBox: TPaintBox;
    LightHeight: TScrollBar;
    RaytracingCheckBox: TCheckBox;
    Smooth: TScrollBar;
    Label16: TLabel;
    CombineLightProcTex: TButton;
    SinglePassSmoothing: TCheckBox;
    AddProcTexButton: TButton;
    JvHotLink3: TJvHotLink;
    Label17: TLabel;
    procedure FormShow(Sender: TObject);
    procedure HeightmapViewButtonClick(Sender: TObject);
    procedure HeightMapCreateButtonClick(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure CreatePerlinNoiseButtonClick(Sender: TObject);
    procedure LoadHeightmapButtonClick(Sender: TObject);
    procedure SaveHeightmapButtonClick(Sender: TObject);
    procedure NotImplemented(Sender: TObject);
    procedure CreditsButtonClick(Sender: TObject);
    procedure ProceduralTextureCreateClick(Sender: TObject);
    procedure EditClick(Sender : TObject);
    procedure CreateProceduralTexButtonClick(Sender: TObject);
    procedure ProceduralTextureViewButtonClick(Sender: TObject);
    procedure SaveProceduralTextureButtonClick(Sender: TObject);
    procedure LightMapSaveButtonClick(Sender: TObject);
    procedure LightingViewClick(Sender: TObject);
    procedure LightingCreateClick(Sender: TObject);
    procedure LightingCreateButtonClick(Sender: TObject);
    procedure LightPostionBoxPaint(Sender: TObject);
    procedure LightRotationChange(Sender: TObject);
    procedure CombineLightProcTexClick(Sender: TObject);
    procedure AddProcTexButtonClick(Sender: TObject);
  private
    { Private-Deklarationen }
    HeightMap : TBitMap;
    ProceduralTex : TBitMap;
    LightMaptex : TBitMap;
    ProcTexs : Array of TProcTexStage;
    procedure AddProcTex(Filename : String; fStage : LongInt);
    procedure AlignProcTexs;
    procedure RemoveProcTex(Index : LongInt);
    procedure WMRemoveProcTex(var Message : TMessage); message CM_REMOVE_PROCTEX;
  public
    { Public-Deklarationen }
  end;

var
  MainForm: TMainForm;

implementation

{$R *.DFM}

procedure TMainForm.FormShow(Sender: TObject);
begin
  //Heightmap Bitmap erzeugen
  HeightMap := TBitMap.Create;
  HeightMap.Width := 64;
  HeightMap.Height := 64;
  with HeightMap.Canvas do
  begin
    Pen.Color := clBlack;
    Brush.Color := clBlack;
    Rectangle(0,0, 63, 63)
  end;

  ProceduralTex := TBitMap.Create;
  ProceduralTex.Width := 64;
  ProceduralTex.Height := 64;
  with ProceduralTex.Canvas do
  begin
    Pen.Color := clBlack;
    Brush.Color := clBlack;
    Rectangle(0,0, 63, 63)
  end;

  LightMapTex := TBitMap.Create;
  LightMapTex.Width := 64;
  LightMapTex.Height := 64;
  with LightMapTex.Canvas do
  begin
    Pen.Color := clBlack;
    Brush.Color := clBlack;
    Rectangle(0,0, 63, 63)
  end;

  Randomize;
  PerlinRandomSeed.Value := Random(65535);

  //Procedural Textures laden
  AddProcTex(ExtractFileDir(ParamStr(0))+'\underwater.bmp',0);
  AddProcTex(ExtractFileDir(ParamStr(0))+'\sand.bmp',60);
  AddProcTex(ExtractFileDir(ParamStr(0))+'\grass.bmp',100);
  AddProcTex(ExtractFileDir(ParamStr(0))+'\rock.bmp',170);
  AddProcTex(ExtractFileDir(ParamStr(0))+'\snow.bmp', 255);

  //Willkommen anzeigen
  StartGroupBox.BringToFront
end;

procedure TMainForm.HeightmapViewButtonClick(Sender: TObject);
begin
  HeightMapImage.Picture.BitMap := HeightMap;
  HeightMapWidth.Caption := 'Width: '+IntToStr(HeightMap.Width);
  HeightMapHeight.Caption := 'Height: '+IntToStr(HeightMap.Height);
  HeightMapView.BringToFront
end;

procedure TMainForm.HeightMapCreateButtonClick(Sender: TObject);
begin
  HeightmapCreate.BringToFront
end;

procedure TMainForm.FormDestroy(Sender: TObject);
var
  I : Integer;
begin
  //Procedural Textures entladen
  for I := 0 to Length(ProcTexs) - 1 do
  begin
    ProcTexs[I].Image.Free;
    ProcTexs[I].StageLabel.Free;
    ProcTexs[I].ScrollBox.Free
  end;
  ProceduralTex.Free;
  LightMapTex.Free;
  HeightMap.Free
end;

procedure TMainForm.CreatePerlinNoiseButtonClick(Sender: TObject);
var
  Noise : TNoise;
  X,Y : LongInt;
  F : Single;
  Octave : LongInt;
  MaxOctaves : LongInt;
  I : LongInt;
  XScale, YScale : Single;

begin
  //Perlin noise erzeugen
  Noise := TNoise.Create(PerlinRandomSeed.Value);
  HeightMap.Width := NewWidth.Value;
  HeightMap.Height := NewHeight.Value;
  MaxOctaves := PerlinOctaves.Value;
  XScale := PerlinXScale.Value;
  YScale := PerlinYScale.Value;

  JVProgress.Maximum := NewWidth.Value - 1;
  JVProgress.AutoTimeLeft := True;
  JVProgress.Text := 'Creating Heightmap';
  JVProgress.Show;
  JVProgress.Value := 0;
  JVProgress.StartProgression;
  for X := 0 to NewWidth.Value - 1 do
  begin
    for Y := 0 to NewHeight.Value - 1 do
    begin
      F := 0;
      I := 1;
      for Octave := 1 to MaxOctaves do
      begin
        F := F + Noise.Noise(X/XScale*I, Y/YScale*I, 0)/I;
        I := I * 2
      end;
      F := F + 0.05;
      //F := F * 1.2;
      //F := F / 1.2;
      if F > 1.0 then F := 1.0;
      if F < 0 then F := 0.0;
      HeightMap.Canvas.Pixels[X,Y] := RGB(Trunc(F*255), Trunc(F*255), Trunc(F*255))
    end;
    JVProgress.Value := X;
    Application.ProcessMessages
  end;
  JVProgress.Close;
  Noise.Free;
  HeightMapViewButton.Click
end;

procedure TMainForm.LoadHeightmapButtonClick(Sender: TObject);
begin
  if OpenDialog.Execute then
  begin
    HeightMapImage.Picture.Bitmap.LoadFromFile(OpenDialog.FileName);
    HeightMap.LoadFromFile(OpenDialog.Filename)
  end
end;

procedure TMainForm.SaveHeightmapButtonClick(Sender: TObject);
begin
  if SaveDialog.Execute then
    HeightMap.SaveToFile(SaveDialog.Filename);
end;

procedure TMainForm.NotImplemented(Sender: TObject);
begin
  MessageBeep(32);
  MessageDlg('Sorry, this option is not implemented yet', mtError, [mbAbort], 0)
end;

procedure TMainForm.CreditsButtonClick(Sender: TObject);
begin
  StartGroupBox.BringToFront
end;

procedure TMainForm.ProceduralTextureCreateClick(Sender: TObject);
begin
  AlignProcTexs;
  ProcTexSettings.BringToFront
end;

procedure TMainForm.AddProcTex(Filename: String; fStage: Integer);
var
  Tex : LongInt;
begin
  if not FileExists(Filename) then Exit;
  Tex := Length(ProcTexs);
  SetLength(ProcTexs, Tex+1);
  with ProcTexs[Tex] do
  begin
    ScrollBox := TScrollBox.Create(ProceduralTexturesBox);
    ScrollBox.Width := 150+4;
    ScrollBox.Height := 150+4;
    ScrollBox.Left := 0;
    ScrollBox.Top := 0;
    ScrollBox.Parent := ProceduralTexturesBox;

    Image := TImage.Create(ScrollBox);
    Image.AutoSize := True;
    Image.Parent := ScrollBox;
    Image.OnClick := EditClick;
    try
      Image.Picture.LoadFromFile(Filename)
    except
    end;
    Stage := fStage;
    StageLabel := TLabel.Create(ScrollBox);
    StageLabel.Caption := IntToStr(Stage);
    StageLabel.Transparent := True;
    StageLabel.Parent := ScrollBox
  end
end;

procedure TMainForm.AlignProcTexs;
const
  Abstand = 24;
  Size = 150;

  procedure Sort(L,R: LongInt);
  var
    i,j : LongInt;
    w,x : TProcTexStage;
  begin
    i := L;
    j := R;
    x := ProcTexs[(L+R) DIV 2];
    repeat
      while ProcTexs[i].Stage < x.Stage do Inc(i);
      while x.Stage < ProcTexs[j].Stage do Dec(j);
      if i <= j then
      begin
        w := ProcTexs[i];
        ProcTexs[i] := ProcTexs[j];
        ProcTexs[j] := w;
        Inc(i); Dec(j)
      end;
    until i > j;
    if L < j then Sort(L,j);
    if i < R then Sort(i,R)
  end;

var
  I : Integer;
  X, Y : LongInt;
begin
  if Length(ProcTexs) = 0 then Exit;
  Sort(0, Length(ProcTexs) - 1);

  X := Abstand;
  Y := Abstand;
  for I := 0 to Length(ProcTexs) - 1 do
  begin
    ProcTexs[I].ScrollBox.Left := X;
    ProcTexs[I].ScrollBox.Top := Y;
    ProcTexs[I].Image.Tag := I;
    X := X + Size + Abstand;
    if X + Size >= ProceduralTexturesBox.ClientWidth then
    begin
      X := Abstand;
      Y := Y + Size + Abstand
    end
  end
end;

procedure TMainForm.RemoveProcTex(Index: Integer);
var
  Temp : Array of TProcTexStage;
  I, I2 : Integer;
begin
  Assert((Index >= 0) and (Index < Length(ProcTexs)));
  SetLength(Temp, Length(ProcTexs)-1);
  I := 0;
  for I2 := 0 to Length(ProcTexs)-1 do
    if I2 <> Index then
    begin
      Temp[I] := ProcTexs[I2];
      Inc(I)
    end;
  ProcTexs[Index].Image.Free;
  ProcTexs[Index].StageLabel.Free;
  ProcTexs[Index].ScrollBox.Free;
  SetLength(ProcTexs, Length(Temp));
  for I2 := 0 to Length(ProcTexs)-1 do
    ProcTexs[I2] := Temp[I2]
end;

procedure TMainForm.WMRemoveProcTex(var Message: TMessage);
begin
  RemoveProcTex(Message.LParam);
  AlignProcTexs
end;

procedure TMainForm.CreateProceduralTexButtonClick(Sender: TObject);
  procedure CheckProcTexs;
  begin
    //Die erste Textur muss stage 0 haben
    ProcTexs[0].Stage := 0;
    ProcTexs[0].StageLabel.Caption := '0';
    //Die letzte Textur muss stage 255 haben
    ProcTexs[Length(ProcTexs)-1].Stage := 255;
    ProcTexs[Length(ProcTexs)-1].StageLabel.Caption := '255';
  end;

type
  TRGB = Array[0..2] of Byte;

  procedure MakeRGB(Color : TColor; var RGB : TRGB);
  begin
    Move(Color, RGB[0], 3)
  end;

var
  X,Y, HeightMapHeight : LongInt;
  I : Integer;
  Upper, Lower : LongInt;
  LevelDifference : LongInt;
  LowerDifference : LongInt;
  LowerRGB, UpperRGB : TRGB;
  FinalRGB : TRGB;
  Prozent : Single;

begin
  //Texturen sind bereits sortiert...
  if Length(ProcTexs) < 2 then
    Exit;
  //Kleiner checkup
  CheckProcTexs;
  ProceduralTex.Width := HeightMap.Width;
  ProceduralTex.Height := HeightMap.Height;

  JVProgress.Maximum := HeightMap.Width - 1;
  JVProgress.AutoTimeLeft := True;
  JVProgress.Text := 'Creating Procedural Texture';
  JVProgress.Show;
  JVProgress.Value := 0;
  JVProgress.StartProgression;
  for X := 0 to HeightMap.Width - 1 do
  begin
    for Y := 0 to HeightMap.Height - 1 do
    begin
      HeightMapHeight := Trunc((HeightMap.Canvas.Pixels[X,Y]/clWhite)*255);
      Upper := 0;
      Lower := 0;
      //Intervall suchen, das fr diese Hhenstufe interessant ist
      for I := 1 to Length(ProcTexs)-1 do
        if HeightMapHeight <= ProcTexs[I].Stage then
        begin
          Upper := I;
          Lower := I -1;
          Break
        end;
      Assert(Upper <> 0);
      LevelDifference := ProcTexs[Upper].Stage - ProcTexs[Lower].Stage;
      LowerDifference := HeightMapHeight - ProcTexs[Lower].Stage;
      Assert(LevelDifference <> 0);
      Prozent := LowerDifference / LevelDifference;

      MakeRGB(ProcTexs[Lower].Image.Canvas.Pixels[X mod ProcTexs[Lower].Image.Width,
        Y mod ProcTexs[Lower].Image.Height],LowerRGB);
      MakeRGB(ProcTexs[Upper].Image.Canvas.Pixels[X mod ProcTexs[Upper].Image.Width,
        Y mod ProcTexs[Upper].Image.Height],UpperRGB);

      for I := 0 to 2 do
        FinalRGB[I] := Trunc((UpperRGB[I] - LowerRGB[I])*Prozent + LowerRGB[I]);
      ProceduralTex.Canvas.Pixels[X,Y] := RGB(FinalRGB[0], FinalRGB[1], FinalRGB[2])
    end;
    JVProgress.Value := X;
    Application.ProcessMessages
  end;
  JVProgress.Close;
  ProceduralTextureViewButton.Click
end;

procedure TMainForm.ProceduralTextureViewButtonClick(Sender: TObject);
begin
  ProceduralTextureImage.Picture.Bitmap := ProceduralTex;
  ProceduralTexureView.BringToFront
end;

procedure TMainForm.SaveProceduralTextureButtonClick(Sender: TObject);
begin
  SaveDialog.Title := 'Save Procedural Texture as';
  if SaveDialog.Execute then
    ProceduralTex.SaveToFile(SaveDialog.Filename);
  SaveDialog.Title :=  'Save Heightmap as'
end;

procedure TMainForm.LightMapSaveButtonClick(Sender: TObject);
begin
  SaveDialog.Title := 'Save Lightmap Texture as';
  if SaveDialog.Execute then
    LightmapTex.SaveToFile(SaveDialog.Filename);
  SaveDialog.Title :=  'Save Heightmap as'
end;

procedure TMainForm.LightingViewClick(Sender: TObject);
begin
  LightMapImage.Picture.BitMap := LightMapTex;
  LightMapView.BringToFront
end;

procedure TMainForm.LightingCreateClick(Sender: TObject);
begin
  LightMapCreate.BringToFront
end;

procedure TMainForm.LightingCreateButtonClick(Sender: TObject);
type
  TRay = record
           Origin, Direction : TVertex
         end;
  //Normalen werden als Bytes abgespeichert
  TNormalMap = Array of Array[0..2] of ShortInt;

  procedure CreateNormalMap(HM : TBitMap; HeightScale : Single; var NormalMap : TNormalMap);
  const
    VertexPoss : Array[0..8] of Array[0..1] of ShortInt =
      ((0,0),(1,-1),(1,0),(1,1),(0,1),(-1,1),(-1,0),(-1,-1),(0,-1));
    Faces : Array[0..7] of Array[0..2] of Byte =
      ((0,1,8),(0,2,1),(0,4,2),(4,3,2),(0,5,4),(0,6,5),(0,8,6),(8,7,6));
  var
    X,Z : LongInt;
    I : LongInt;
    VertexPosMultiply : LongInt;

    Vertieces : Array[0..8] of TVertex;
    Normals   : Array[0..7] of TVertex;
    Normale : TVertex;
  begin
    (* Vertex/Face Tabelle
           v8
      v7#---#---#v1
        |8 /|1 /|
        | / | / |
        |/ 7|/ 2|
      v6#--v0---#v2
        |6 /|3 /|
        | / | / |
        |/ 5|/ 4|
      v5#---#---#v3
            v4*)

    SetLength(NormalMap, HM.Width*HM.Height);
    JVProgress.Text := 'Step 1/3: Normals';
    JVProgress.Maximum := HM.Height -1;
    JVProgress.StartProgression;
    FillChar(Vertieces[0,0], SizeOf(Vertieces), 0);

    for Z := 0 to HM.Height - 1 do
    begin
      for X := 0 to HM.Width - 1 do
      begin
        Normale[0] := 0;
        Normale[1] := 0;
        Normale[2] := 0;
        if not SinglePassSmoothing.Checked then
        begin
          for VertexPosMultiply := 1 to Smooth.Position do
          begin
            //Mehrmals normalen berechnen
            //Vertieces holen
            for I := 0 to 8 do
            begin
              Vertieces[I][0] := X + VertexPoss[I][0]*VertexPosMultiply;
              Vertieces[I][2] := Z + VertexPoss[I][1]*VertexPosMultiply;
              Vertieces[I][1] := HM.Canvas.Pixels[X + VertexPoss[I][0]*VertexPosMultiply, Z + VertexPoss[I][1]*VertexPosMultiply]
                /clWhite*255*HeightScale
            end;
            //Normalen holen
            for I := 0 to 7 do
            begin
              Normals[I] := VectorCrossProduct(
                VectorNormalize(VectorSubtract(Vertieces[Faces[I][0]],Vertieces[Faces[I][1]])),
                VectorNormalize(VectorSubtract(Vertieces[Faces[I][1]],Vertieces[Faces[I][2]])));
              Normals[I] := VectorNormalize(Normals[I])
            end;
            //Den "Durchschnittsvektor"...
            for I := 0 to 7 do
              Normale := VectorAdd(Normale, Normals[I]);
          end;
          NormalizeVector(Normale)
        end
        else
        begin
          //1 mal Normalen berechnen
          VertexPosMultiply := Smooth.Position;
          for I := 0 to 8 do
          begin
            Vertieces[I][0] := X + VertexPoss[I][0]*VertexPosMultiply;
            Vertieces[I][2] := Z + VertexPoss[I][1]*VertexPosMultiply;
            Vertieces[I][1] := HM.Canvas.Pixels[X + VertexPoss[I][0]*VertexPosMultiply, Z + VertexPoss[I][1]*VertexPosMultiply]
              /clWhite*255*HeightScale
          end;
          //Normalen holen
          for I := 0 to 7 do
          begin
            Normals[I] := VectorCrossProduct(
              VectorNormalize(VectorSubtract(Vertieces[Faces[I][0]],Vertieces[Faces[I][1]])),
              VectorNormalize(VectorSubtract(Vertieces[Faces[I][1]],Vertieces[Faces[I][2]])));
            Normals[I] := VectorNormalize(Normals[I])
          end;
          //Den "Durchschnittsvektor"...
          for I := 0 to 7 do
            Normale := VectorAdd(Normale, Normals[I]);
          NormalizeVector(Normale)
        end;
        Normale := VectorScale(Normale,127.0);
        NormalMap[Z*(HM.Height) + X][0] := Trunc(Normale[0]);
        NormalMap[Z*(HM.Height) + X][1] := Trunc(Normale[1]);
        NormalMap[Z*(HM.Height) + X][2] := Trunc(Normale[2])
      end;
      JVProgress.Value := Z;
      Application.ProcessMessages
    end
  end;

  procedure CreateLightMap(HM : TBitMap; HeightMapScale : Single;
    NormalMap : TNormalMap; Sun : TVertex; LightMap : TBitMap; LightAmbient, LightDiffuse : Single; Raytracing : Boolean);

  var
    HeightMapData : Array of Array of byte;

    procedure PrecacheHeightmap;
    var
      X,Z : LongInt;
    begin
      SetLength(HeightMapData, HM.Width);
      for X := 0 to Length(HeightMapData) -1 do
        SetLength(HeightMapData[X], HM.Height);

      JVProgress.Text := 'Step 2/3: Precaching Heightmap';
      JVProgress.Maximum := HeightMap.Height -1;
      JVProgress.StartProgression;
      for Z := 0 to HM.Height - 1 do
      begin
        for X := 0 to HM.Width - 1 do
          HeightMapData[X,Z] := Trunc(HM.Canvas.Pixels[X,Z]/clWhite * 255);
        JVProgress.Value := Z;
        Application.ProcessMessages
      end
    end;


    function RayIntersected(Ray : TRay; HM : TBitMap; HeightMapScale : Single):Boolean;
    var
       Position : TVertex;
       Vor : TVertex;
    begin
      Result := False;
      Position := Ray.Origin;
      Vor := VectorNormalize(Ray.Direction);
      Position := VectorAdd(Position, Vor);
      while (Position[0] > 0) and (Position[0] < HM.Width - 1) and
        (Position[2] > 0) and (Position[2] < HM.Height - 1) do
      begin
        if HeightMapData[Trunc(Position[0]), Trunc(Position[2])]*
          HeightMapScale >= Position[1] then
        begin
          Result := True;
          Break
        end;
        Position := VectorAdd(Position, Vor)
      end
    end;

  var
    X,Z : LongInt;
    Ray : TRay;
    //SunScale : Single;
    n : TVertex;
    f : Single;
  begin
    //Wir haben paraleles Licht, also bleibt der Richtungsvektor des
    //Rays immer gleich
    if Raytracing then PrecacheHeightmap;

    //SunScale := HM.Width * 5;
    //Sun := VectorScale(VectorNormalize(Sun), SunScale);
    Ray.Direction := VectorNormalize(Sun);

    JVProgress.Text := 'Step 3/3: Lighting';
    JVProgress.Maximum := HM.Height -1;
    JVProgress.StartProgression;

    for Z := 0 to HM.Height - 1 do
    begin
      for X := 0 to HM.Width - 1 do
      begin
        Ray.Origin[0] := X;
        Ray.Origin[1] := HM.Canvas.Pixels[X,Z]/clWhite*255*HeightMapScale;
        Ray.Origin[2] := Z;
        if RayTracing and RayIntersected(Ray, HM, HeightMapScale) then
          f := LightAmbient
        else begin
          n[0] := NormalMap[Z*(HM.Height) + X][0];
          n[1] := NormalMap[Z*(HM.Height) + X][1];
          n[2] := NormalMap[Z*(HM.Height) + X][2];

          f := LightAmbient+ LightDiffuse*(VectorDotProduct(VectorNormalize(n),VectorNormalize(Ray.Direction)));
          if f > 1.0 then f := 1.0;
          if f < 0.0 then f := 0.0
        end;
        LightMap.Canvas.Pixels[X,Z] := RGB(Trunc(f*255), Trunc(f*255), Trunc(f*255))
      end;
      JVProgress.Value := Z;
      Application.ProcessMessages
    end
  end;

var
  Sun : TVertex;
  HeightMapScale : Single;
  NormalMap : TNormalMap;

begin
  JVProgress.AutoTimeLeft := True;
  JVProgress.Show;
  JVProgress.Value := 0;

  Sun[0] := Cos(LightRotation.Position*Pi/180);
  Sun[1] := (LightHeight.Max - LightHeight.Position)/100;
  Sun[2] := Sin(LightRotation.Position*Pi/180);
  HeightMapScale := HeightScaleEdit.Value;

  LightMapTex.Width := HeightMap.Width;
  LightMapTex.Height := HeightMap.Height;

  CreateNormalMap(HeightMap, HeightMapScale, NormalMap);
  JVProgress.AutoTimeLeft := False;
  CreateLightMap(HeightMap, HeightMapScale, NormalMap, Sun, LightMapTex,
    AmbientLight.Position / 100, DiffuseLight.Position/100, RaytracingCheckBox.Checked);

  JVProgress.Close;
  LightingView.Click
end;

procedure TMainForm.LightPostionBoxPaint(Sender: TObject);
var
  Bmp : TBitMap;
begin
  Bmp := TBitMap.Create;
  Bmp.Width := 100;
  Bmp.Height := 100;
  with Bmp.Canvas do
  begin
    Pen.Color := clBlack;
    Brush.Color := clWhite;
    Ellipse(0,0,99,99);
    Pen.Color := clRed;
    MoveTo(50,50);
    LineTo(50+Trunc(50*cos(LightRotation.Position*Pi/180)), 50+Trunc(50*sin(LightRotation.Position*Pi/180)));
  end;
  LightPostionBox.Canvas.Draw(0,0, Bmp);
  Bmp.Free
end;

procedure TMainForm.LightRotationChange(Sender: TObject);
begin
  LightPostionBox.Refresh
end;

procedure TMainForm.CombineLightProcTexClick(Sender: TObject);
type
  TRGB = Array[0..2] of Byte;

  procedure MakeRGB(Color : TColor; var RGB : TRGB);
  begin
    Move(Color, RGB[0], 3)
  end;

var
  X,Z : LongInt;
  EndRGB : TRGB;
  Lighting : Single;
  I : Integer;

begin
  JVProgress.AutoTimeLeft := True;
  JVProgress.Show;
  JVProgress.Value := 0;
  JVProgress.Maximum := ProceduralTex.Width - 1;
  JVProgress.Text := 'Combining Light+Proc Tex';
  JVProgress.StartProgression;
  for X := 0 to ProceduralTex.Width - 1 do
  begin
    for Z := 0 to ProceduralTex.Width - 1 do
    begin
      MakeRGB(ProceduralTex.Canvas.Pixels[X,Z], EndRGB);
      Lighting := LightMaptex.Canvas.Pixels[X,Z] / clWhite;
      for I := 0 to 2 do
        EndRGB[I] := Trunc(EndRGB[I]*Lighting);
      LightMaptex.Canvas.Pixels[X,Z] := RGB(EndRGB[0], EndRGB[1], EndRGB[2])
    end;
    JVProgress.Value := X;
    Application.ProcessMessages
  end;
  JVProgress.Close;
  LightingView.Click
end;

procedure TMainForm.EditClick(Sender: TObject);
var
  ProcTex : LongInt;
begin
  ProcTex := (Sender as TComponent).Tag;
  ProcTexs[ProcTex].Image.Parent := EditProcTexStage.ScrollBox;
  EditProcTexStage.Image := ProcTexs[ProcTex].Image;
  EditProcTexStage.Stage.Position := ProcTexs[ProcTex].Stage;
  if EditProcTexStage.ShowModal = mrNo then
    PostMessage(MainForm.Handle, CM_REMOVE_PROCTEX, 0, ProcTex)
  else
  begin
    ProcTexs[ProcTex].Stage := EditProcTexStage.Stage.Position;
    ProcTexs[ProcTex].StageLabel.Caption := IntToStr(ProcTexs[ProcTex].Stage);
    ProcTexs[ProcTex].Image.Parent := ProcTexs[ProcTex].ScrollBox;
    ProcTexs[ProcTex].Image.SendToBack;
    AlignProcTexs
  end
end;

procedure TMainForm.AddProcTexButtonClick(Sender: TObject);
begin
  AddProcTex(ExtractFileDir(ParamStr(0))+'\snow.bmp', 255);
  AlignProcTexs
end;

end.


